from osgeo import ogr
import os
## READ
driver = ogr.GetDriverByName('ESRI SHAPEFILE')
datasource = driver.Open('src/P_test.shp')
layer = datasource.GetLayer(0)
layerDefn = layer.GetLayerDefn()

## INFOS
#nb Field
nbFieldShp = layerDefn.GetFieldCount()
#nb Feat
nbFeatShp =  layer.GetFeatureCount()

# We stock fields Name, fields Type and Fields Width
fieldNameShp, fieldTypeShp, fieldWidthShp = [], [], []
for i in xrange(nbFieldShp):
    fieldNameShp.append(layerDefn.GetFieldDefn(i).GetName())
    fieldTypeShp.append(layerDefn.GetFieldDefn(i).GetType())
    fieldWidthShp.append(layerDefn.GetFieldDefn(i).GetWidth())
    
if os.path.isfile('src/P_test2.shp')==True:
    os.remove('src/P_test2.shp')
    os.remove('src/P_test2.shx')
    os.remove('src/P_test2.dbf')

## WRITE
newDriver = ogr.GetDriverByName('ESRI SHAPEFILE')
newDatasource =newDriver.CreateDataSource('src/P_test2.shp')
newLayer =newDatasource.CreateLayer('P_test2', None , 1)

# Create Field
for i in xrange(nbFieldShp):
    newField= ogr.FieldDefn(fieldNameShp[i], fieldTypeShp[i])
    newField.SetWidth(fieldWidthShp[i])
    newLayer.CreateField(newField)
    

# Write Features
for i in xrange(nbFeatShp):
    newFeature = ogr.Feature(newLayer.GetLayerDefn())
    # Read Shp Feature
    feature = layer.GetFeature(i)
    for j in xrange(nbFieldShp):
        data = feature.GetField(j)
        # Write New Feature
        newFeature.SetField(fieldNameShp[j], data)
    # Stock Geometry Shp Feature
    x = feature.GetGeometryRef().GetX()
    y = feature.GetGeometryRef().GetY()
    xBase = int((int(x/1)*1))
    yBase = int((int(y/1)*1))
    if x - xBase >= 0.5:
        x = xBase+0.75
    else:
        x = xBase+0.25
    if y - yBase >= 0.5:
         y = yBase+0.75
    else:
         y = yBase+0.25
    #Create Geometry
    newGeometry = ogr.Geometry(feature.GetGeometryRef().GetGeometryType())
    newGeometry.AddPoint(x,y)
    #Write Geometry
    newFeature.SetGeometry(newGeometry)
    #The Feat is ready create Feat
    newLayer.CreateFeature(newFeature)
    newFeature.Destroy()
newDatasource.Destroy()
        
print 'done !'
    